<template>
  <div :style="{ backgroundColor: isFieldEdited({ node, path }) ? 'rgba(255, 255, 255, 0.5)' : '' }">
    <h4>{{ title }}</h4>
    <pre>{{ path }}</pre>
    <!-- {{ config }} -->
    <!-- {{ fieldsConfig }} -->
    <div v-for="(value, key) in fieldsConfig" :key="key" :style="{ backgroundColor: isFieldEdited({ node, path: [...path, key] }) ? 'rgba(255, 255, 255, 0.5)' : '' }">
    {{ fieldsConfig[key] }}
      <div v-if="fieldsConfig[key]">
      <!-- {{ fieldsConfig[key].label }} -->
        <div v-if="fieldsConfig[key].paragraph" class="paragraph">
          {{ fieldsConfig[key].label }}
          <div v-if="fieldsConfig[key].multi" class="multi">
            <div v-if="isArray(nodeData[key]) && nodeData[key].length">
              <list-items-paragraph-form :node="node" :path="[...path, key]" :config="fieldsConfig[key]"></list-items-paragraph-form>
              <!-- <div v-for="(embed, index) in nodeData[key]" :key="embed.pid" class="paragraph-item">
                <items-paragraph-form :title="fieldsConfig[key].label + (embed.pid ? ' #' + embed.pid : ' new')" :node="node" :path="[...path, key, index]" :config="fieldsConfig[key]"></items-paragraph-form>
                <delete-item-multi-form :node="node" :path="[...path, key, index]" :config="fieldsConfig[key]"></delete-item-multi-form>
              </div> -->
            </div>
            <div v-else>
              <!-- <items-paragraph-form :title="fieldsConfig[key].label +  ' new'" :node="node" :path="[...path, key, 0]" :config="fieldsConfig[key]"></items-paragraph-form> -->
            </div>
            <new-item-form :node="node" :path="[...path, key]" :config="fieldsConfig[key]"></new-item-form>
            <!-- <items-form ></items-form> -->
            <!-- <label>
              {{ fieldsConfig.label }}
              <component :is="'text-field'" :node="node" :config="fieldsConfig"></component>
            </label> -->
          </div>
          <div v-else>
            <div v-if="nodeData[key]">
              <items-paragraph-form :title="fieldsConfig[key].label + (nodeData[key] && nodeData[key].pid ? ' #' + nodeData[key].pid : ' new')" :node="node" :path="[...path, key]" :config="fieldsConfig[key]"></items-paragraph-form>
              <delete-item-form :node="node" :path="[...path, key]" :config="fieldsConfig[key]"></delete-item-form>
            </div>
            <div v-else>
              <new-item-form :node="node" :path="[...path, key]" :config="fieldsConfig[key]"></new-item-form>
            </div>
            <!-- <div v-for="index in (Array.isArray(nodeData[key]) ? nodeData[key].length - 1 : 0)" :key="index">
              <items-paragraph-form :title="fieldsConfig[key].label + (nodeData[key] && nodeData[key][index] ? ' #' + nodeData[key][index].pid : ' new')" :node="node" :path="[...path, key, index]" :config="fieldsConfig[key]"></items-paragraph-form>
            </div> -->

            <!-- <pre>{{ nodeData[key] }}</pre> -->

          </div>
        </div>
        <div v-else>
          <div v-if="fieldsConfig[key].multi" class="multi">
            {{ fieldsConfig[key].label }}
            <div v-if="isArray(nodeData[key]) && nodeData[key].length">
              <list-item-form :node="node" :path="[...path, key]" :config="fieldsConfig[key]"></list-item-form>

              <!-- <div v-for="(embed, index) in nodeData[key]" :key="embed.nid">
                <item-form :label="fieldsConfig[key].label + ' #' + (index + 1)" :node="node" :path="[...path, key, index]" :config="fieldsConfig[key]"></item-form>
               <delete-item-multi-form :node="node" :path="[...path, key, index]" :config="fieldsConfig[key]"></delete-item-multi-form>
              </div> -->
            </div>
            <div v-else>
              <!-- <item-form :node="node" :path="[...path, key, 0]" :config="fieldsConfig[key]" :index="0"></item-form> -->
              <!-- <label>
                {{ fieldsConfig[key].label }} {{ [...path, key, 0] }}
                <component :is="'text-field'" :node="node" :path="[...path, key, 0]" :config="fieldsConfig[key]"></component>

                {{ fieldsConfig[key].label }} {{ [...path, key, 0] }}
                <component :is="'text-field'" :node="node" :path="[...path, key, 0]" :config="fieldsConfig[key]"></component>
              </label> -->
              <!-- LOOO -->
              <!-- <items-form :title="fieldsConfig[key].label + ' new'" :node="node" :path="[...path, key, 0]" :config="fieldsConfig[key]"></items-form> -->
            </div>
            <new-item-form :node="node" :path="[...path, key]" :config="fieldsConfig[key]"></new-item-form>
          </div>
          <div v-else>
            <item-form :node="node" :path="[...path, key]" :config="fieldsConfig[key]"></item-form>
            <!-- <label>
              {{ fieldsConfig[key].label }} {{ [...path, key] }} {{ fieldsConfig[key].read_only ? 'READ ONLY' : '' }} {{ fieldsConfig[key].read_only && (!nodeData[key] || nodeData[key].length === 0) ? 'HIDDEN' : '' }}
              <component :is="'text-field'" :node="node" :path="[...path, key]" :config="fieldsConfig[key]"></component>
            </label> -->
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import _ from 'lodash'

import { mapGetters } from 'vuex'

// import TextField from '@/components/Editable/Fields/Widgets/TextFieldWidgetField'

export default {
  components: {
    // TextField,
    ListItemsParagraphForm: () => import('./ListItemsParagraphForm.vue'),
    ListItemForm: () => import('./ListItemForm.vue'),
    ItemsParagraphForm: () => import('./ItemsParagraphForm.vue'),
    ItemsForm: () => import('./ItemsForm.vue'),
    ItemForm: () => import('./ItemForm.vue'),
    NewItemForm: () => import('./NewItemForm.vue'),
    DeleteItemForm: () => import('./DeleteItemForm.vue')
  },

  props: {
    title: {
      type: String,
      required: true
    },
    node: {
      type: Object,
      required: true
    },
    path: {
      type: Array,
      required: false,
      default: () => []
    },
    config: {
      type: Object,
      required: true
    }
  },

  data () {
    return {
      // excludeList: ['_type', 'nid']
    }
  },
  // watch: {
  //   nodeData: {
  //     handler (val) {
  //       console.log('node')
  //     },
  //     deep: true
  //   }
  // },

  computed: {
    ...mapGetters({
      isFieldEdited: 'Y3TI/isFieldEdited'
    }),

    nodeData () {
      return _.isEmpty(this.path) ? this.node : _.get(this.node, this.path, {})
    },

    fieldsConfig () {
      return this.config.fields || {}
    }
    // nodesList () {
    //   return this.getEditableNodes(this.$route.path)
    // }
    // editablePath () {
    //   return [ this.node._type, 'nid-' + this.node.nid, ...this.path ]
    // },

    // textfieldData () {
    //   return this.getEditableData(this.editablePath) || _.get(this.node, this.path)
    // }
  },

  methods: {
    // ...mapActions({
    //   storeEditableFieldData: 'Y3TI/storeEditableFieldData'
    // }),
    isEmpty: _.isEmpty,
    isArray: _.isArray

    // update (e) {
    //   this.storeEditableFieldData({ data: { path: this.editablePath, input: e.target.innerHTML } })
    // }
  }
}
</script>

<style lang="scss" scoped>
  .paragraph {
    border: 2px solid black;
    padding: 5px;
  }
  .multi {
    padding: 10px;
    border: 2px solid white;
  }
</style>
